In a previous tutorial, I wrote about how to code a ridiculously good-looking jQuery chat room. Rather than build an overly-simple chat app, I challenged us to include advanced features like message history. In this tutorial, we’ll take things one step further by introducing chat push notifications.
Above, the app shows notifications when the window is in the foreground. I wanted to include foreground notifications for demo purposes. We will also leverage a service worker to render background notifications, even when the page isn’t open.
Because this tutorial picks up where the last one ends, it’s up to you if you’d like to follow on from the beginning or clone the repository and continue from there.
Getting started
I created a starter template based on the previous tutorial and uploaded it to this repository. Go ahead and download it to your local machine as shown here:
git clone https://github.com/cometchat-pro-tutorials/jquery-push-starter.git
Once you are done, open the project in your editor of choice. This project contains a couple of files, image assets, and directories that hold the logic to make the app function as a basic jQuery chat application. Here is a quick overview of the relevant files and directories:
index.html: This is the main file for the application. It is sometimes referred to as the entry point. It contains the simple HTML elements for the chat application and also the links to the SDK that will be used to power the application.
css/style.css: stylesheet to add more custom styles, which includes colors and other user interface enhancement for the application
assets: It holds the images for the chat app
js: This directory houses two script files chatService.js and scripts.js. These files contain the required logic to authenticate users on CometChat, participate in a chat session and also retrieve older messages amongst other things.
Now that you have a starter template and have a full understanding of the existing folder structure, you can now proceed to make use of CometChat JavaScript SDK to make the application work, but first, you need to create an account.
Creating CometChat account
If you followed the previous tutorial, you’ll know all about CometChat. Otherwise, here is a quick introduction.
CometChat is a chat platform, which makes it trivial to add voice, video, and text chat to your applications. In our case, we code the front-end then connect to CometChat to send and receive messages in real-time, store message history, and more. We’ll also be leveraging the CometChat push notifications extension to connect with Firebase Cloud Messaging.
To connect to CometChat, you’ll need to create a free account then an app. This will take a few seconds. Once it’s done, click the Explore button to view your newly-created application. Copy and save both your app ID and full access key from the API Keys menu:
Add CometChat credential globally
Back in the code, navigate to ./js/scripts.js file and add your CometChat credentials as a global variable as shown here:
// js/scripts
$(document).ready(function() {
// Global variables
window.COMETCHAT_APP_ID = 'YOUR_COMMETCHAT_APP_ID';
window.COMETCHAT_API_KEY = 'YOUR_COMMETCHAT_API_KEY';
...
});
This will make it so easy to reference and make use of these variables within your application. Replace the YOUR_COMMETCHAT_APP_ID and YOUR_COMMETCHAT_API_KEY placeholder with the appropriate credentials as obtained from your CometChat dashboard.
To be sure that the downloaded starter template works like a group chat application, for now, go ahead and run the index.html file in a browser. Open from two different tabs and log in on each tab using the following test users; superhero1, superhero2, superhero3 from CometChat:
If your app worked as shown above, then you are on track and ready to include the push notifications feature. Otherwise, kindly check your code again and ensure that your CometChat credentials are filled appropriately.
Setting up Firebase project
Firebase is a platform that provides lots of services for both web and mobile applications and facilitates the quick development of apps without managing infrastructure. To enable push notifications for our chat application, we will use a service called Firebase Cloud Messaging (FCM), which will enable us to send messages to any device using HTTP requests.
To begin, you need to have a Firebase account and add a new project within it. Click here to create a new Firebase account, if you don’t have one already. Next, from your Firebase console, create a new project by clicking on the Create a project button:
You will be prompted to enter your project name. Once you are done, click on the </> symbol to add a new web app to your project:
Enter a name for your app and register it. You will see a page similar to the one shown below afterward:
Copy and save the Firebase config snippet somewhere, as we will need this later.
If you have an existing Firebase project for an application that you wish to integrate CometChat, you can easily select the project and download the config file instead of creating another.
Enabling CometChat push notifications extension
Now that we have created a Firebase project and a web app within it, you need to go back to your CometChat dashboard and enable the push notification extension for the app that you added on CometChat earlier. Click on Extensions from the left side menu:
Then from the list of all extensions, click on the Add Extension button on the Push Notification row:
Add FCM Server key
To complete the process of enabling the Push notification extension on CometChat, a Firebase Cloud Messaging server key is required. Head back to your Firebase console and click on Project Settings. Then select the Cloud Messaging tab to obtain it as shown here:
Copy the FCM Server Key and from the CometChat dashboard, click on Actions → Settings for the installed extension:
Paste the Server key in the dialog box and give your notification a title:
Now, that you have created a Firebase project, created a web app, enable the push notifications extension on CometChat and added the FCM server key, your CometChat application is almost set to start communicating properly with Firebase. To complete the process, we will initialize and configure Firebase messaging within the chat application in the next section.
Add and configure Firebase messaging in your application
Here, you will configure push notifications by creating a new file named pushNotification.js within the js folder. Now open this newly created file and use the following content for it:
// /js/pushNotification.js
const pushNotificationService = function() {
let firebaseUid = '';
return {
initializeFirebase: function() {
if (firebase.messaging.isSupported()) {
const firebaseConfig = {
apiKey: "YOUR_FIREBASE_APIKEY",
authDomain: "YOUR_FIREBASE_DOMAIN",
databaseURL: "FIREBASE_DATABASE_URL",
projectId: "FIREBASE_PROJECT_ID",
storageBucket: "STORAGE_BUCKET",
messagingSenderId: "FIREBASE_MESSAGE_SENDER_ID",
appId: "FIREBASE_APP_ID",
};
firebase.initializeApp(firebaseConfig);
const messaging = firebase.messaging();
messaging
.requestPermission()
.then(() => {
console.log("Have Permission");
return messaging.getToken();
})
.then(token => {
var userType = 'group';
var UID = "supergroup";
var appId = COMETCHAT_APP_ID;
var topic = appId + '_' + userType + '_' + UID;
var url = `https://ext-push-notifications.cometchat.com/fcmtokens/${token}/topics/${topic}`;
fetch(url, {
method: 'POST',
headers: new Headers({
'Content-Type': 'application/json',
}),
body: JSON.stringify({appId: appId}),
})
.then(response => {
if (response.status < 200 || response.status >= 400) {
console.log(
'Error subscribing to topic: ' +
response.status +
' - ' +
response.text()
);
}
})
.catch(error => {
console.error(error);
});
})
.catch(error => {
if (error.code === 'messaging/permission-blocked') {
console.log('Please Unblock Notification Request Manually');
} else {
console.log('Error Occurred', error);
}
});
}
},
}
}();
First, you imported Firebase and created a firebaseConfig() object to hold the configuration details of the app created on Firebase console. Kindly replace all the placeholders with the appropriate credentials obtained from the Firebase config snippet earlier.
Next, because it is important to seek the consent of your app users before displaying a push notification, you used the messaging.requestPermission() function to ask a user for permission to send push notification from your chat app, once granted, you retrieved the token by using the messaging.getToken() function. If permission is denied, the Firebase console messaging registration token requests will result in an error.
You then proceeded to use the retrieved token to subscribe to a topic. Topics in Firebase cloud messaging allows messages to be sent to multiple devices that have subscribed to such a particular topic. You can create a random topic and allow any other devices to opt-in for it and they will receive notifications based on that. You can read more about this feature here. At the moment because of the subscription, your browser will receive a message object each time a chat message is being sent to the chat room.
Lastly, add the following code just after the .catch() method:
const pushNotificationService = function() {
let firebaseUid = '';
return {
initializeFirebase: function() {
if (firebase.messaging.isSupported()) {
...
messaging.onMessage(function(payload) {
var sender = JSON.parse(payload.data.message);
console.log('Receiving foreground message', JSON.parse(payload.data.message));
// Customize notification here
if (sender.data.entities.sender.entity.uid !== firebaseUid) {
var notificationTitle = 'CometChat JQuery Push Notification';
var notificationOptions = {
body: payload.data.alert,
icon: sender.data.entities.sender.entity.avatar,
};
var notification = new Notification(notificationTitle, notificationOptions);
notification.onclick = function(event) {
notification.close();
console.log(event);
};
}
});
}
},
}
}();
This will ensure that all the message object sent to the browser as a result of the topic subscribed to, will be handled properly. Here, you used the Notification API to create a new push notification. Before creating the notification payload, we checked to ensure that the sender is not the currently logged in user. This will enable us to control when to display push notifications. The rationale behind this ensures that a user should not receive push notifications for his message.
To track the details of the currently logged in user, add the following code within ./src/pushNotification.js:
const pushNotificationService = function() {
let firebaseUid = '';
return {
...
updateFirebaseLoggedInUser: function(uid) {
if (firebase.messaging.isSupported()) {
firebaseUid = uid;
}
}
}
}();
Now you can invoke the newly added method immediately you obtained the details of the logged-in user. To achieve that, open the chatService.js, locate the getLoggedInUser() method and update it as shown here:
const chatService = function() {
...
return {
...
getLoggedInUser: function() {
CometChat.getLoggedinUser().then(
user => {
...
// update firebase logged in user
pushNotificationService.updateFirebaseLoggedInUser(user.uid);
...
},
error => {
console.log(error);
}
)
},
...
}
}();
Initialize Firebase instance
Navigate back to the script file and initialize firebase:
$(document).ready(function() {
...
// Initialize firebase
pushNotificationService.initializeFirebase(); // add this line
...
});
Here, you referenced and invoked the initializeFirebase() function from pushNotification.js. This will ensure that a new Firebase instance will be initialized whenever the application is running.
Receive notifications in the background using the service worker
To keep receiving notifications even when your application is in the background, you will need to add a service worker. This is a script that your browser will keep running in the background, thereby ensuring that you keep receiving push notifications. By default, when you start Firebase, it looks for a file called firebase-messaging-sw.js in a location where your files are served.
Create a new file named firebase-messaging-sw.js within the root of the application and paste the following content in it:
// /firebase-messaging-sw.js
importScripts("https://www.gstatic.com/firebasejs/6.4.0/firebase-app.js");
importScripts("https://www.gstatic.com/firebasejs/6.4.0/firebase-messaging.js");
if (firebase.messaging.isSupported()) {
var firebaseConfig = {
messagingSenderId: "YOUR_FIREBASE_MESSAGING_SENDER_ID"
};
firebase.initializeApp(firebaseConfig);
const messaging = firebase.messaging();
messaging.setBackgroundMessageHandler(function(payload) {
console.log(' Received background message ', payload);
var sender = JSON.parse(payload.data.message);
var notificationTitle = 'CometChat JQuery Push Notification';
var notificationOptions = {
body: payload.data.alert,
icon: sender.data.entities.sender.entity.avatar,
};
return self.registration.showNotification(
notificationTitle,
notificationOptions
);
});
self.addEventListener('notificationclick', function(event) {
event.notification.close();
//handle click event onClick on Web Push Notification
});
}
The messaging.setBackgroundMessageHandler() function will listened and received messages as payload and use it to create a push notification. Replace the YOUR_FIREBASE_MESSAGING_SENDER_ID placeholder with your Firebase app messagingSenderId.
Finally, update the index.html file by including Firebase SDK and the created pushNotifications script immediately after jQuery scripts as shown below:
// /index.html
<!DOCTYPE html>
<html lang="en">
<head>
...
</head>
<body>
...
<!-- Firebase SDK -->
<script src="https://www.gstatic.com/firebasejs/6.4.0/firebase-app.js"></script>
<script src="https://www.gstatic.com/firebasejs/6.4.0/firebase-messaging.js"></script>
<!-- Push notifications scripts -->
<script src="js/pushNotification.js"></script>
...
</body>
</html>
Testing the application.
Open the index.html again or refresh the page if you’re tab hoarder! You’ll see this:
Next, open the application on two different browsers and log in as separate users. You can log in with any two of the test users provided by CometChat for every new application: superhero1, superhero2, superhero3 as shown here. Send a message to continue a chat session and you will receive push notifications:
Conclusion
In this tutorial, you have successfully learned how to add push notifications feature to an existing jQuery chat application in no time. You start by downloading an existing code from the previous tutorial which contains the required amount of code for a functional group chat application powered by CometChat. You then proceeded to leverage CometChat and Firebase Messaging Service to add push notifications features.
This will increase and enhance user interactivity for your application. The complete source code for this application built here can be found on GitHub. Feel free to download it and add more features as you deem fit.

Wajahat Karim
CometChat

One of the most efficient and non-intrusive ways of providing realtime messages or information to your web application users is through the use of push notifications. It makes your application quite engaging and here at CometChat, we have put together an infrastructure to enable the process of achieving such functionality in your web app.
In this tutorial, I will show you how to build a group chat application with Vuejs and leverage on CometChat and Firebase to add web push notification to it as shown here:
We will use services offered by Firebase for push notifications and combine it with the awesome chat features from CometChat to build this.
To obtain access to the entire source code for the complete application in this tutorial, you can check this repository. You are welcome to also follow the step by step guide here in this tutorial.
We are going to use a Vue.js boilerplate from this repository to kickstart our application. The project in this repository contains a couple of required dependencies that you will need to install, the image assets specifically for this project and a stylesheet to give the app an appealing look. We will be using the main branch, which is the starter-branch as the starting place.
To begin, download or clone the repository using Git as shown here:
{% c-line %} git clone https://github.com/cometchat-pro-tutorials/vue-push-notifications.git{% c-line-end %}
Once the installation process is complete, navigate to the project directory and install all the dependencies:
{% c-block %}
// change directory
cd vue-push-notifications
// install dependencies
npm install
{% c-block-end %}
This will install the following crucial packages:
With the starter project which contains minimal code and functionality installed successfully, here is a quick overview of the most important files and directories in it:
The basic setup for the Vue application has been completed and we will add more features later in the tutorial. You can run the application now with:
npm run serve
This will start the app on the development server available on http://localhost:8080. We will start making this app more functional in the next section.
As pointed out earlier, CometChat will be used as a service provider to power our chat application and in conjunction with Firebase, a push notification will be enabled. With CometChat you can easily add voice, video, and text chat to your application. Also, it also provides extensions which leverage on other services such as Firebase.
Start with CometChat by heading over to the website and create a free CometChat Pro account. Fill in all the required information and you will have a trial account set up for you. Then, head to your CometChat dashboard, then add a new app by selecting v1 from the dropdown and enter the desired name for your app. I have aptly named mine web-notification-vue. Proceed to click on the + sign and wait for a couple of seconds for your new app to be created.
Once this is done, you will be redirected back to the initial page where your new app will be listed. Click the Explore button and then go to the API Keys tab. Copy and save both your APP ID and the API Key with fullAccess scope ****that was automatically generated for your application, somewhere, ****as you will need it later.
Let’s proceed to set up the group chat app and add more functionalities. We will come back to the dashboard later.
Next, create a new file named .env within the root directory of the application and paste the following code in it:
{% c-block %}
// .env
VUE_APP_COMMETCHAT_API_KEY=YOUR_API_KEY
VUE_APP_COMMETCHAT_APP_ID=YOUR_APP_ID
VUE_APP_COMMETCHAT_GUID=YOUR_GUID
{% c-block-end %}
Replace YOUR_API_KEY, YOUR_APP_ID, YOUR_GUID placeholder with the appropriate credentials as obtained from your CometChat dashboard.
Next, it is required that CometChat must be initialised in an application using the APP ID obtained from the dashboard before any method can be called from the CometChat SDK. The code to do this has been included in the downloaded sample project earlier. Open the root component in ./src/App.vue and let’s take a look at its content:
{% c-block language="javascript" %}
// ./src/App.vue
<template>
<div id="app">
<router-view/>
</div>
</template>
<script>
import { CometChat } from "@cometchat-pro/chat";
import "./App.css";
export default {
created() {
this.initializeApp();
},
methods: {
initializeApp() {
const { VUE_APP_COMMETCHAT_APP_ID } = process.env
CometChat.init(VUE_APP_COMMETCHAT_APP_ID).then(
() => {
console.log("Initialization completed successfully");
},
error => {
console.log("Initialization failed with error:", error);
}
);
}
}
};
</script>
{% c-block-end %}
Here, the <router-view> is a functional component that was included to render any matched component for a given path from Vue Router. The configuration for each routes can be found in ./src/router.js, feel free to take a look at it, to have an understanding of the components that will be rendered once we visit a particular route within the app.
Lastly in the file above, we called init() by passing the APP ID as a parameter to initialize the settings required for CometChat. With this in place, CometChat SDK will be aware that our application exists.
Now that the initialization of CometChat is successful, we will add more contents to the Login component. This is to give a particular user access to send and receive messages from CometChat server.
{% c-block language="html" %}
// ./src/views/Login.vue
<template>
<div class="login-page">
<div class="login">
<div class="login-container">
<div class="login-form-column">
<form v-on:submit.prevent="authLoginUser">
<h3>Hello!</h3>
<p>Welcome to our little Vue demo powered by CometChat. Login with the username "superhero1" or "superhero2" and test the chat out.
To create your own user, see <a href="https://prodocs.cometchat.com/reference#createuser">our documentation</a></p>
<div class="form-wrapper">
<label>Username</label>
<input type="text" name="username" id="username" v-model="username" placeholder="Enter your username" class="form-control" required>
</div>
<button type="submit">LOG IN <span v-if="showSpinner" class="fa fa-spin fa-spinner"></span></button>
</form>
</div>
</div>
</div>
</div>
</template>
<script>
import { CometChat } from "@cometchat-pro/chat";
export default {
data() {
return {
username: "",
showSpinner: false
};
},
methods: {
authLoginUser() {
var apiKey = process.env.VUE_APP_COMMETCHAT_API_KEY;
this.showSpinner = true;
CometChat.login(this.username, apiKey).then(
() => {
this.showSpinner = false;
this.$router.push({
name: "chat"
});
},
error => {
this.showSpinner = false;
alert("Whops. Something went wrong. This commonly happens when you enter a username that doesn't exist. Check the console for more information")
console.log("Login failed with error:", error.code);
}
);
}
}
};
</script>
{% c-block-end %}
What the method authLoginUser() does is to obtain the username inputted by a user and pass it to the Login() method from CometChat SDK. If the process of authenticating the user was successful we will redirect the user to the Chat page through the help of Vue Router; which handles navigation for the application. Otherwise, a prompt, with the appropriate message indicating that the login process failed will be displayed.
The Chat component is not anywhere close to what we want to achieve at the moment. Let us begin to flesh it up by adding the required contents to make it functional. Start by opening the ./src/views/Chat.vue and replace its content with the following code:
{% c-block language="html" %}
<template>
<div class="booker">
<div class="chat">
<div class="container">
<div class="msg-header">
<div class="active">
<h5>Chat</h5>
</div>
</div>
<div class="chat-page">
<div class="msg-inbox">
<div class="chats" id="chats">
<div class="msg-page" id="msg-page">
<div
v-if="loadingMessages"
class="loading-messages-container"
>
<spinner :size="100"/>
<span class="loading-text">
Loading Messages
</span>
</div>
<div class="text-center img-fluid empty-chat" v-else-if="!groupMessages.length" >
<div class="empty-chat-holder">
<img src="../assets/empty-state.svg" class="img-res" alt="empty chat image">
</div>
<div>
<h2> No new message? </h2>
<h6 class="empty-chat-sub-title">
Send your first message below.
</h6>
</div>
</div>
<div v-else>
<div>
<div v-for="(message, i) in groupMessages" v-bind:key="`${i}-${message.id}`">
<div class="received-chats" v-if="message.sender.uid != uid">
<div class="received-chats-img">
<img v-bind:src="message.sender.avatar" alt="" class="avatar">
</div>
<div class="received-msg">
<div class="received-msg-inbox">
<p><span>{{ message.sender.uid }}</span><br>{{ message.data.text }}</p>
</div>
</div>
</div>
<div class="outgoing-chats" v-else>
<div class="outgoing-chats-msg">
<p>{{ message.data.text }}</p>
</div>
<div class="outgoing-chats-img">
<img v-bind:src="message.sender.avatar" alt="" class="avatar">
</div>
</div>
</div>
</div>
</div>
</div>
</div>
</div>
<div class="msg-bottom">
<form class="message-form" v-on:submit.prevent="sendGroupMessage">
<div class="input-group">
<input type="text" class="form-control message-input" placeholder="Type something" v-model="chatMessage" required>
<spinner
v-if="sendingMessage"
class="sending-message-spinner"
:size="30"
/>
</div>
</form>
</div>
</div>
</div>
</div>
</div>
</template>
{% c-block-end %}
Here, once a user is authenticated and redirected to the chat page, we will receive the user details and display the unique username, avatar and also an empty chat page for users who just joined a new group with no previous messages.
Also included is a form with an input field that will be used by a user to send a message to a group. The form will be processed by a method named sendGroupMessage() which will be implemented later in this section .
We need to uniquely identify the current logged in user and to achieve that, we will retrieve the details of the user by calling a method named getLoggedInUser(). This will return a User object containing all the information related to the logged-in user. We will begin by adding this <script> section to our code. Place the contents below within the Chat.vue immediately after the closing tag of the <template> section:
{% c-block language="javascript" %}
// ./src/views/Chat.vue
<script>
import { CometChat } from "@cometchat-pro/chat";
import Spinner from "../components/Spinner.vue";
export default {
name: "home",
components: {
Spinner
},
data() {
return {
username: "",
avatar: "",
uid: "",
sendingMessage: false,
chatMessage: "",
loggingOut: false,
groupMessages: [],
loadingMessages: false
};
},
created() {
this.getLoggedInUser();
},
methods: {
getLoggedInUser() {
CometChat.getLoggedinUser().then(
user => {
this.username = user.name;
this.avatar = user.avatar;
this.uid = user.uid;
},
error => {
this.$router.push({
name: "homepage"
});
console.log(error);
}
);
},
}
};
</script>
{% c-block-end %}
Above, we imported the Spinner component, including the CometChat method from the SDK. Also, we defined some properties and corresponding initial values within the data option. And finally, once the component is created, we called a method named getLoggedInUser() to automatically retrieve the details of a logged in user and update the view alongside it.
At the moment, none of the members will be able to send real-time message to the group yet, even after being authenticated. We will change this by adding methods to send group messages, listen for any new message posted to the group in realtime and fetch all previous messages.
To send new message from our app to CometChat server, add a new method named sendGroupMessage() immediately after the getLoggedInUser() method:
{% c-block language="javascript" %}
// ./src/views/Chat.vue
<script>
...
export default {
...
methods: {
...
sendGroupMessage() {
this.sendingMessage = true;
var receiverID = process.env.VUE_APP_COMMETCHAT_GUID;
var messageText = this.chatMessage;
var messageType = CometChat.MESSAGE_TYPE.TEXT;
var receiverType = CometChat.RECEIVER_TYPE.GROUP;
let globalContext = this;
var textMessage = new CometChat.TextMessage(
receiverID,
messageText,
messageType,
receiverType
);
CometChat.sendMessage(textMessage).then(
message => {
console.log("Message sent successfully:", message);
this.chatMessage = "";
this.sendingMessage = false;
// Text Message Sent Successfully
this.groupMessages = [...globalContext.groupMessages, message];
this.$nextTick(() => {
this.scrollToBottom()
})
},
error => {
console.log("Message sending failed with error:", error);
}
);
}
},
};
</script>
{% c-block-end %}
Sending messages to either a group or user on CometChat requires creating an object TextMessage class. Here, we instantiate this object and passed the mandatory parameters which are:
Once the message is posted to the server, we updated the groupMessages property with the new message and added a method to scroll to the latest message. Add this scroll method after sendGroupMessage() function as shown below:
{% c-block language="javascript" %}
...
scrollToBottom() {
const chat = document.getElementById("msg-page");
chat.scrollTo(0, chat.scrollHeight + 30);
},
...
{% c-block-end %}
To receive real-time incoming messages posted to a group by its participants, we would register an event listener and pass a unique listenerID to it. Also, CometChat SDK makes provision to fetch messages in bulk using the MessagesRequestBuilder class. We will add all these functionalities within a lifecycle hook in Vuejs called mounted. Go ahead and include the content below just before the created() lifecycle hook:
{% c-block language="javascript" %}
// ./src/views/Chat.vue
<script>
...
export default {
...
data() {
...
},
mounted() {
this.loadingMessages = true;
var listenerID = "UNIQUE_LISTENER_ID";
const messagesRequest = new CometChat.MessagesRequestBuilder()
.setLimit(100)
.build();
messagesRequest.fetchPrevious().then(
messages => {
console.log("Message list fetched:", messages);
console.log("this.groupMessages", this.groupMessages);
this.groupMessages = [...this.groupMessages, ...messages];
this.loadingMessages = false;
this.$nextTick(() => {
this.scrollToBottom();
});
},
error => {
console.log("Message fetching failed with error:", error);
}
);
CometChat.addMessageListener(
listenerID,
new CometChat.MessageListener({
onTextMessageReceived: textMessage => {
console.log("Text message received successfully", textMessage);
// Handle text message
console.log(this.groupMessages);
this.groupMessages = [...this.groupMessages, textMessage];
// console.log("avatar", textMessage.sender.avatar)
this.loadingMessages = false;
this.$nextTick(() => {
this.scrollToBottom();
});
}
})
);
},
created() {
...
},
methods: {
...
}
};
</script>
{% c-block-end %}
Once a user logs in, we will use the MessagesRequestBuilder to fetch any previous messages from the group and update the view with it.
In case you miss anything, the complete contents of the Chat.vue file can be found here.
Firebase is a platform that provides lots of services for both web and mobile applications and facilitates the quick development of apps without managing infrastructure. To enable push notifications for our chat application, we will use a service called Firebase Cloud Messaging (FCM), which will enable us to send messages to any device using HTTP requests.
To begin, you need to have a Firebase account and add a new project within it. Click here to create a new Firebase account, if you don’t have one already. Next, from your Firebase console, create a new project by clicking on the Create a project button:
You will prompted to enter your project name. Once you are done, click on the </> symbol to add a new web app to your project:
Enter a name for your app and register it. You will see a page similar to the one shown below afterward:
Copy and save the Firebase config snippet somewhere, as we will need this later.
Note: 💡 If you have an existing Firebase project for an application that you wish to integrate CometChat, you can easily select the project and download the config file instead of creating another.
Now that we have created a Firebase project and a web app within it, you need to go back to your CometChat dashboard and enable the push notification extension for the app that you added on CometChat earlier. Click on Extensions from the left side menu:
Then from the list of all extensions, click on the Add Extension button on the Push Notification row:
To complete the process of enabling Push notification extension on CometChat, a Firebase Cloud Messaging server key is required. Head back to your Firebase console and click on Project Settings. Then select the Cloud Messaging tab to obtain it as shown here:
Copy the FCM Server Key and from the CometChat dashboard, click on Actions → Settings for the installed extension:
Paste the Server key in the dialog box and give your notification a title:
Now, that you have created a Firebase project, created a web app, enable the push notifications extension on CometChat and added the FCM server key, your CometChat application is almost set to start communicating properly with Firebase. To complete the process, we will initialize and configure Firebase messaging within the chat application in the next section.
To begin, a Firebase SDK will be used here to enable communication between your chat application and Firebase. We have already installed this package earlier as it was included in the package.json file of the downloaded sample project.
Next, create a pushNotifications.js file within the src folder, then copy and paste the following code to it:
{% c-block language="javascript" %}
// ./src/pushNotifications.js
import firebase from 'firebase/app';
import 'firebase/messaging';
export function initializeFirebase() {
if (firebase.messaging.isSupported()) {
const firebaseConfig = {
apiKey: "YOUR_FIREBASE_API_KEY",
authDomain: "YOUR_FIREBASE_AUTH_DOMAIN",
databaseURL: "YOUR_FIREBASE_DATABASE_URL",
projectId: "YOUR_FIREBASE_PROJECT_ID",
storageBucket: "",
messagingSenderId: "YOUR_FIREBASE_MESSAGING_SENDER_ID",
appId: "YOUR_FIREBASE_APP_ID",
measurementId: "YOUR_FIREBASE_MEASUREMENT_ID"
};
firebase.initializeApp(firebaseConfig);
const messaging = firebase.messaging();
messaging
.requestPermission()
.then(() => {
console.log("Permission granted");
return messaging.getToken();
})
.then(token => {
var userType = 'group';
var UID = process.env.VUE_APP_COMMETCHAT_GUID;
var appId = process.env.VUE_APP_COMMETCHAT_APP_ID;
var topic = appId + '_' + userType + '_' + UID;
var url = `https://ext-push-notifications.cometchat.com/fcmtokens/${token}/topics/${topic}`;
fetch(url, {
method: 'POST',
headers: new Headers({
'Content-Type': 'application/json',
}),
body: JSON.stringify({appId: appId}),
})
.then(response => {
if (response.status < 200 || response.status >= 400) {
console.log(
'Error subscribing to topic: ' +
response.status +
' - ' +
response.text()
);
}
})
.catch(error => {
console.error(error);
});
})
.catch(error => {
if (error.code === 'messaging/permission-blocked') {
console.log('Please Unblock Notification Request Manually');
} else {
console.log('Error Occurred', error);
}
});
}
}
{% c-block-end %}
The code snippet above might look a bit daunting. Let’s try to break it down. First, we imported Firebase and created a firebaseConfig() object to hold the configuration details of the app created on Firebase console. Kindly replace all the placeholders with the appropriate credentials obtained from the Firebase config snippet earlier.
Next, because it is important to seek the consent of your app users before displaying a push notification, we used the messaging.requestPermission() function to ask a user for permission to send push notification from our chat app, once granted, we retrieved the token by using the messaging.getToken() function. If permission is denied, the Firebase console messaging registration token requests will result in an error.
We then proceeded to use the retrieved token to subscribe to a topic. Topics in Firebase cloud messaging allows messages to be sent to multiple devices that have subscribed to such a particular topic. You can create a random topic and allow any other devices to opt-in for it and they will receive notifications based on that. You can read more about this feature here. At the moment because of the subscription, your browser will receive a message object each time a chat message is being sent to the chat room.
Lastly, add the following code just after the .catch() method:
{% c-block language="javascript" %}
// ./src/pushNotification.js
...
export function initializeFirebase() {
if (firebase.messaging.isSupported()) {
...
messaging.onMessage(function(payload) {
var sender = JSON.parse(payload.data.message);
console.log('Receiving foreground message', JSON.parse(payload.data.message));
// Customize notification here
if (sender.data.entities.sender.entity.uid !== firebaseUid) {
var notificationTitle = 'CometChat Pro Notification';
var notificationOptions = {
body: payload.data.alert,
icon: sender.data.entities.sender.entity.avatar,
};
var notification = new Notification(notificationTitle, notificationOptions);
notification.onclick = function(event) {
notification.close();
console.log(event);
};
}
});
}
}
{% c-block-end %}
This will ensure that all the message object sent to the browser as a result of the topic subscribed to, will be handled properly. Here, we used the Notification API to create a new push notification. Before creating the notification payload, we checked to ensure that the sender is not the currently logged in user. This will enable us to control when to display push notifications. The rationale behind this ensures that a user should not receive push notifications for his message.
To track the details of the currently logged in user, add the following code within ./src/pushNotification.js:
{% c-block language="javascript" %}
// ./src/pushNotification.js
...
let firebaseUid = '';
export function initializeFirebase(){
...
}
...
export function updateLoggedInUser(uid){
if (firebase.messaging.isSupported()) {
firebaseUid = uid;
}
}
{% c-block-end %}
Finally, call the newly created method within ./src/views/Chat.vue as shown below:
{% c-block language="javascript" %}
// ./src/views/Chat.vue
...
import { updateLoggedInUser } from './../pushNotification';
methods: {
getLoggedInUser() {
CometChat.getLoggedinUser().then(
user => {
...
updateLoggedInUser(this.uid)
},
...
);
},
}
{% c-block-end %}
Next, you will need to create an instance of the initializeFirebase() function created here once the application start running.
Initialize Firebase instance
Go back to the root component for this application in App.vue and import the configuration above:
{% c-block language="javascript" %}
// ./src/App.vue
...
<script>
...
import { initializeFirebase } from './pushNotification';
export default {
created() {
...
initializeFirebase();
},
...
};
</script>
{% c-block-end %}
Here, you imported the initializeFirebase() function from pushNotification.js and invoke it. This will ensure that a new Firebase instance will be initialized whenever the application is running.
To keep receiving notifications even when your application is in the background, you will need to add a service worker. This is a script that your browser will keep running in the background, thereby ensuring that you keep receiving push notifications. By default, when you start Firebase, it looks for a file called firebase-messaging-sw.js in a location where your files are served.
Create this file within the ./public and paste the following code in it:
{% c-block language="javascript" %}
// ./public/firebase-messaging-sw.js
importScripts("https://www.gstatic.com/firebasejs/6.4.0/firebase-app.js");
importScripts("https://www.gstatic.com/firebasejs/6.4.0/firebase-messaging.js");
if (firebase.messaging.isSupported()) {
var firebaseConfig = {
messagingSenderId: "YOUR_FIREBASE_MESSAGING_SENDER_ID"
};
firebase.initializeApp(firebaseConfig);
const messaging = firebase.messaging();
messaging.setBackgroundMessageHandler(function(payload) {
console.log(' Received background message ', payload);
var sender = JSON.parse(payload.data.message);
var notificationTitle = 'CometChat Pro Notification';
var notificationOptions = {
body: payload.data.alert,
icon: sender.data.entities.sender.entity.avatar,
};
return self.registration.showNotification(
notificationTitle,
notificationOptions
);
});
self.addEventListener('notificationclick', function(event) {
event.notification.close();
//handle click event onClick on Web Push Notification
});
}
{% c-block-end %}
The messaging.setBackgroundMessageHandler() function will listened and received messages as payload and use it to create a push notification. Replace the YOUR_FIREBASE_MESSAGING_SENDER_ID placeholder with your Firebase app messagingSenderId
Go ahead and restart the application with npm run serve if its currently not running. Open two different tabs and try to send message from one browser. You will receive push notifications
In this tutorial, you have learned how to build a Vuejs group chat application and add push notifications feature to it by using CometChat JavaScript SDK and Firebase.One important takeaway here is the usage of service worker which ensures that your web push notifications show even when your website is closed.
I do hope that you found this tutorial helpful. The complete source code for the application built here can be found in the master branch of this repository.

Add Push Notifications to Your React Chat App

Last updated
October 8, 2019
by
No items found.

Push notifications are an important feature of any modern chat application. Notifications ensure your messages are the first users see when they pick up their device and that your product is always front of mind.

Add Push Notifications to Your React Chat App

Table of Contents

    Push notifications are an important feature of any modern chat application. Notifications ensure your messages are the first users see when they pick up their device and that your product is always front of mind.

    In this tutorial, you will first learn to build a simple React group chat application before enabling push notifications with CometChat and the CometChat Push notifications extension. Here’s a sneak peak of what you’ll build:

    Showing a push notification

    If you’d like to jump straight into code, you can grab the complete code on GitHub.

    Creating CometChat Account

    CometChat is a developer tool that enables you to add text, voice, and video chat to your web and mobile applications. Aside from core chat features like groups, real-time messaging, and typing indicators, CometChat provides a multitude of powerful extensions which leverage other services. In this tutorial, we’ll be using the Firebase push notifications extension. You’re going to love how seamless it is to enable. First, though, you’ll need to create a free CometChat account.

    Head to the dashboard and create your free account. Then, create a CometChat app to connect to its services. From the dashboard, enter your app name in the Add New App box and hit the + icon.

    I called my application "react-chat-pn" but feel free to name it as you wish.

    Adding a new CometChat app

    Hold your horses ⚠️🐴!
    To follow this tutorial or run the example source code you'll need to create a V1 application.


    v2 will be out of beta soon at which point we will update this tutorial.

    Once done, you’ll be taken into the dashboard of your app, preloaded with default users and API key that you can immediately use. Go ahead and click on API Keys. From here, take note of your API key and App ID:

    CometChat API Key and App ID

    And you’re done setting up CometChat. Next up is creating your chat app.

    Setting up React application

    Rather than creating your React application from scratch, you can clone or download the starter code required for this tutorial here. Don’t worry, all it contains are just images, style and packages required to make an awesome chat app. You will still code everything from scratch. Let’s hit the ground running by using the command line npm install.

    While you wait for the installation to finish, here is a short explanation of the project files:

    • The src/assets folder includes svg images that you’re going to use to beautify the app
    • The src/components folder includes minimal placeholder for the app. There’s the Login and Chat component inside, which you will improve later on
    • src/App.css covers the styling of the app. This way you don’t need to write any styling
    • src/App.js is where the app will be initialized. CometChat and Firebase will be called from here
    • src/index.js serve as the entry point of the app

    There are also some extra packages in this repo, they are:

    • @cometchat-pro/chat contains the JavaScript SDK of CometChat
    • react-md-spinner a small library to create spinner when loading chat messages
    • react-notifications create a toast notification, used in Login component later
    • react-router-dom takes care of routing from one React component to another

    Once your installation is finished, rename .env-example file to .env and edit its content with your CometChat credentials:

    {% c-block %}
    REACT_APP_COMETCHAT_API_KEY=YOUR_API_KEY
    REACT_APP_COMETCHAT_APP_ID=YOUR_APP_ID
    REACT_APP_COMETCHAT_GUID=supergroup
    {% c-block-end %}

    Copy and paste your CometChat Api Key to REACT_APP_COMETCHAT_API_KEY and your App ID to REACT_APP_COMETCHAT_APP_ID. You will reference them from the app later.

    You can run npm start and test your React app. It should run without any problem. Of course it doesn’t do anything interesting yet. Let’s change it.

    Building React components

    Before you code the components, let’s take a look at the content of App.js file:

    {% c-block language="ruby" %}
    import React from 'react';
    import {CometChat} from '@cometchat-pro/chat';
    import {BrowserRouter as Router, Route} from 'react-router-dom';
    import {NotificationContainer} from 'react-notifications';
    import './App.css';
    import 'react-notifications/lib/notifications.css';
    import Login from './components/Login';
    import Chat from './components/Chat';
    CometChat.init(process.env.REACT_APP_COMETCHAT_APP_ID);
    const App = () => {
     return (
    <Router>
    <React.Fragment>
    <NotificationContainer />
    <Route exact path='/' component={Login} />
    <Route path='/login' component={Login} />
    <Route path='/chat' component={Chat} />
    </React.Fragment>
    </Router>
     );
    };
    export default App;
    {% c-block-end %}

    This App component will act as the container of the entire chat app. CometChat is initialized with CometChat.init function, then three routes are declared inside the Router component, one for default /, one for /login and the last for /chat route.

    The default and /login route will render the Login component, while /chat will render Chatcomponent. NotificationContainer component will be responsible for displaying toast notification on the authentication process.

    We’ll take care of these two components and complete the app before we work on push notification, so let’s start with editing the Login component.

    Building the Login component

    As its name implies, the primary job of Login component is to log the user into CometChat server, so that the user can send and receive message from CometChat.

    First, we define the component, the layout and a simple form. The handleLogin function is the most important one for this component, and we’ll work on it next. For now, write down the component like this:

    {% c-block language="javascript" %}
    import React from 'react';
    import { CometChat } from '@cometchat-pro/chat';
    import { NotificationManager } from 'react-notifications';
    import loginIllustration from '../assets/login-illustration.svg';
    class Login extends React.Component {
     state = {
       username: '',
       isLoading: false,
     };
     handleLogin = event => {
       event.preventDefault();
       console.log("Login handler");
     };
    render() {
     const {username, isLoading} = this.state;
     const loadingSpinner = isLoading? <span className="fa fa-spin fa-spinner"/>  :'';
     return (
    <div className='login-page'>
    <div className='login'>
    <div className='login-container'>
    <div className='login-form-column'>
    <form>
    <h3>Welcome!</h3>
    <p>
                     Login with the username "superhero1" or "superhero2" to test this React-CometChat application. To create your own user, visit{' '}
    <a href='https://prodocs.cometchat.com/reference#createuser'>
                       our documentation
    </a>
    </p>
    <div className='form-wrapper'>
    <label>Username</label>
    <input
                       type='text'
                       name='username'
                       id='username'
                       placeholder='Enter your username'
                       value={username}
                       onChange={event => this.setState({ username: event.target.value })}
                       className='form-control'
                       required
                     />
    </div>
    <button type='submit' onClick={this.handleLogin} disabled={isLoading}>
                     LOG IN {loadingSpinner}
    </button>
    </form>
    </div>
    <div className='login-image-column'>
    <div className='image-holder'>
    <img src={loginIllustration} alt='Login illustration' />
    </div>
    </div>
    </div>
    </div>
    </div>
       );
     }
    }
    export default Login;
    {% c-block-end %}

    In the snippet above, we define a form which asks the user for their username. Once submitted, handleSubmit is called and we activate the loading spinner. To test if our form works, we print the username to the console.

    Of course, we actually want to check and login the user, so let’s do that now. Replace handleLogin code with the following snippet:

    {% c-block language="javascript" %}
    handleLogin = event => {
     event.preventDefault();
     const { username } = this.state;
     if(!username){
       NotificationManager.error('Username must not be empty', 'Login Failed');
       return;
     }
     this.setState({
       isLoading: true
     })
     CometChat.login(username, process.env.REACT_APP_COMETCHAT_API_KEY).then(
       user => {
         NotificationManager.success('You are now logged in', 'Login Success');
         this.setState({ username: '', isLoading: false });
         this.props.history.push({
           pathname: '/chat',
           state: { user }
         })
       },
       error => {
         NotificationManager.error('Username is not registered', 'Login Failed');
         this.setState({
           isLoading: false
         })
       }
     );
    };
    {% c-block-end %}

    First, we check if username is not empty. If it is, we call NotificationManager.error to show an error notification on the top right corner of the screen. The NotificationManager function is imported from react-notifications module.

    Showing error notification to user

    When username is not empty, isLoading state is set to true, which cause React to show a loading indicator and disable the submit button, to prevent multiple submission.

    The function then calls the CometChat.Login function, sending username and CometChat API key as its arguments. If the function returns an error, we use the same NotificationManager I introduced you to earlier to show another error. Since all is good from our side, the most likely reason for this error is the username is not registered. **

    If the username is registered, CometChat will return a success response and a user object. We’ll use NotificationManager.success function to show a Login Success notification, while at the same time React-Router will redirect the browser into /chat route and pass the user object.

    Go ahead and try the app, you should be able to login and get redirected to Chat component.

    Building the Chat component

    With the Login component finished, we can move on into Chat component. Let’s start by defining the states:

    {% c-block language="javascript" %}
    import React from 'react';
    import {CometChat} from '@cometchat-pro/chat';
    import MDSpinner from 'react-md-spinner';
    import emptyChatImage from '../assets/empty-state.svg';
    const {REACT_APP_COMETCHAT_GUID} = process.env;
    class Chat extends React.Component {
     constructor(props) {
       super();
       this.state = {
         message: '',
         chat: [],
         isLoading: true,
         user: props.location.state? props.location.state.user : '',
       };
     }
    }
    export default Chat;
    {% c-block-end %}


    By now, the snippet above should be clear for you, but let me explain the use of these states first.

    • The message state is used to hold the value of user input
    • chat will store an array of text message objects. We will display them later as chat bubbles
    • isLoading will be used to display and remove a loading indicator while the chat component is fetching previous messages
    • user to identify messages sent by the currently logged in user

    Alright, now let’s create a componentDidMount function to fetch any previous messages send to this chat room:

    {% c-block language="javascript" %}
    componentDidMount() {
     var messagesRequest = new CometChat.MessagesRequestBuilder()
       .setGUID(REACT_APP_COMETCHAT_GUID)
       .setLimit(100)
       .build();
     messagesRequest.fetchPrevious().then(
       messages => {
         this.setState({
           chat: messages,
           isLoading: false,
         });
       },
       error => {
         console.log('Message fetching failed with error:', error);
       }
     );
    }
    {% c-block-end %}

    In the snippet above, we created an object of MessagesRequestBuilder class, which is provided by CometChat to fetch messages in bulk. Once the messages are received from CometChat, we assign them into chat state and remove the loading indicator from screen. By implementing this code, the user will see a handful of previous messages instead of an empty chat room whenever they login into the app.

    Another thing you need to do is to set a CometChat message listener that will listen for any incoming message in real-time. Once a message is received, push it into the chat state array:

    {% c-block language="javascript" %}
    componentDidMount() {
     ...
     CometChat.addMessageListener(
       'MESSAGE_LISTENER_KEY',
       new CometChat.MessageListener({
         onTextMessageReceived: message => {
           var {chat} = this.state;
           console.log('Incoming Message Log', {message});
           chat.push(message);
           this.setState({
             chat
           });
         },
       })
     );
    }
    {% c-block-end %}

    So far so good. Let’s create a handleSendMessage that will send user input as a new message to CometChat server.

    First, we need to create a TextMessage object using the new CometChat.TextMessage() function.
    Through the documentation, we learned that the function requires us to specify several mandatory parameters as follows:

    • receiverID: This is to identify the recipient of the message. We will use the GUID imported from .env.
    • messageText: The text message that needs to be sent to the server, taken from our state
    • messageType: The type of message, in our case is a text
    • receiverType: The type of user that will receive the message. In our case, it’s a group

    Finally, we send the message using CometChat.sendMessage function. Once successfully send, we will push the message into chat state array, so that the newly sent message is displayed in the chat box.

    {% c-block language="javascript" %}
    handleSendMessage = event => {
       event.preventDefault();
       const {message} = this.state;
       var textMessage = new CometChat.TextMessage(
         REACT_APP_COMETCHAT_GUID,
         message,
         CometChat.MESSAGE_TYPE.TEXT,
         CometChat.RECEIVER_TYPE.GROUP
       );
       CometChat.sendMessage(textMessage).then(
         message => {
           const { chat } = this.state;
           chat.push(message);
           this.setState({
             chat
           })
           console.log('Message sent successfully:', message);
         },
         error => {
           console.log('Message sending failed with error:', error);
         }
       );
       this.setState({
         message: '',
       });
     };
    {% c-block-end %}

    Now that we’ve taken care about the logic, let’s write the render function to actually display a chat room that we can interact with. This is where we map the value of chat state to create message bubbles. We will also create a simple text input for typing the message:

    {% c-block language="html" %}
    render() {
     var {chat, message, isLoading, user} = this.state;
     var chatContent = (
    <div className='loading-messages-container'>
    <MDSpinner size='100' />
    <span className='loading-text'>Loading Messages</span>
    </div>
     );
     if (!isLoading && !chat.length) {
       chatContent = (
    <div className='text-center img-fluid empty-chat'>
    <div className='empty-chat-holder'>
    <img src={emptyChatImage} className='img-res' alt='empty chat' />
    </div>
    <div>
    <h2> No new message? </h2>
    <h6 className='empty-chat-sub-title'>
               Send your first message below.
    </h6>
    </div>
    </div>
       );
     }
     else if (!isLoading && chat.length) {
       chatContent = chat.map(chat => {
         var isUser = user.uid === chat.sender.uid;
         var renderName;
         if (isUser) {
           renderName = null;
         } else {
           renderName = (
    <div className='sender-name'>{chat.sender.name}</div>
           );
         }
         return (
    <div key={chat.id} className='chat-bubble-row' style={{flexDirection: isUser ? 'row-reverse' : 'row'}}>
    <img src={chat.sender.avatar} alt='sender avatar' className='avatar' style={isUser ? {marginLeft: '15px'} : {marginRight: '15px'}} />
    <div className={`chat-bubble ${isUser? 'is-user':'is-other'}`}>
                 {renderName}
    <div className='message' style={{color: isUser ? '#FFF' : '#2D313F'}}>
                   {chat.text}
    </div>
    </div>
    </div>
         )
       });
     }
     return (
    <div className='chat-container'>
    <div className='chat'>
    <div className='container'>
    <div className='chat-header'>
    <div className='active'>
    <h5>Chat</h5>
    </div>
    </div>
    <div className='chat-page'>
    <div className='msg-page'>
                     {chatContent}
    <div id='endofchat'></div>
    </div>
    <div className='msg-footer'>
    <form
                       className='message-form'
                       onSubmit={this.handleSendMessage}>
    <div className='input-group'>
    <input
                           type='text'
                           className='form-control message-input'
                           placeholder='Type something'
                           value={message}
                           onChange={ event => this.setState({ message: event.target.value }) }
                           required
                         />
    </div>
    </form>
    </div>
    </div>
    </div>
    </div>
    </div>
     );
    }
    {% c-block-end %}


    That’s a bit long for a snippet! Let me break down what it does for you.

    Basically, this render function will have 3 dynamic views which gets rendered depending on the values of local state at the moment. The first one is a loading view, where we show a spinner imported from md-spinner package to indicate that the chat app is fetching previous messages from CometChat:

    Loading messages view

    Once the fetch process is done, we’re going to check if the chat array holds any message for us to display. If there is none, we will display a simple no message illustration and ask the user to send his or her first message:

    No messages view

    Finally, when we have some messages from chat array to render, we display the chat messages for users to view:

    A chat room view with previous messages

    The Chat component is ready for testing, but let’s add a few improvements to make it perfect. First, you can get the app to scroll to the latest message by using a simple scrollIntoView function. Call this function from componentDidUpdate function, so that it will be called each time the state changes. :

    {% c-block language="javascript" %}
    componentDidUpdate() {
     this.scrollToBottom();
    }
    scrollToBottom = () => {
     const chat = document.getElementById("endofchat");
     chat.scrollIntoView();
    }
    {% c-block-end %}

    If you found any error while following the tutorial, you can compare your Chat component code with the one from here.

    By now, your chat application should be working perfectly. Go take a short break for now. When you’re ready, it’s time to add the push notification feature!

    Creating a Firebase project

    We’ll need to make use of Firebase cloud messaging (FCM) in order to add push notification for this chat app, so head over to Firebase website and create a new account if you haven’t had one.

    Once inside Firebase console, add a new project by clicking on the + symbol:

    Creating a new Firebase project

    Then inside your newly created Firebase project, add a new web app by clicking on the </> symbol:

    Adding a web app to Firebase

    Once the web app is added, you will be shown a Firebase config snippet like this:

    Firebase config snippet

    Take note of this config, because you will need it later. For now, let’s move on into CometChat dashboard.

    Enabling CometChat push notification extension

    To enable push notification feature from CometChat, you need to enable the push notification extension from CometChat dashboard, so let’s head back to where you grab CometChat API key and click on the Extensions menu. Add Push Notification from the extensions list:

    Adding push notification extension

    Once the extension is enabled, grab the FCM server key from the screenshot below:

    Getting Firebase server key

    And paste it into the extension by clicking on Actions → Settings:

    Saving FCM server key inside CometChat

    Now CometChat will be able to make use of FCM. Let’s update our chat app to make use of it.

    Adding Firebase messaging to your chat app

    Now we need to install Firebase SDK package to the React app. Let’s do another npm install:

    npm install firebase

    And create a firebase.js file inside our src directory. Here, we will write a function that initialize a firebase instance:

    {% c-block %}
    import firebase from 'firebase/app';
    import 'firebase/messaging';
    export function initializeFirebase() {
     if (firebase.messaging.isSupported()) {
       const config = {
         // your firebase config here
       };
       const init = firebase.initializeApp(config);
     }
    }
    {% c-block-end %}

    Put your Firebase web config into the config constant above and import initializeFirebase function in your App.js file. We’ll call the function from there:

    {% c-block %}
    import {initializeFirebase} from './firebase';
    CometChat.init(process.env.REACT_APP_COMETCHAT_APP_ID);
    initializeFirebase();
    // ... rest of the code
    {% c-block-end %}

    With the snippet above, a new Firebase instance will be initialized when the app is running.

    Now you need to request permission from the user to display push notifications. The messaging.requestPermission function is used to do just that. In the snippet below, we’ll ask for the permission to send push notification, once allowed, we can retrieve a token by using the messaging.getToken function. I will show you what to do with it later, so let’s focus on getting the permission first:

    {% c-block %}
    const messaging = init.messaging();
    messaging.requestPermission()
       .then(() => {
           console.log("Have Permission");
           return messaging.getToken();
       })
       .then(token => {
           console.log("FCM Token:", token);
           //Do something with Token like subscribe to topics
       })
       .catch(error => {
           if (error.code === "messaging/permission-blocked") {
               console.log("Please Unblock Notification Request Manually");
           } else {
               console.log("Error Occurred", error);
           }
       });
    {% c-block-end %}

    Now that we can get the token, let’s figure out what to do with it. We are going to use the token to subscribe to a topic.

    What’s a topic, you asked? It’s a feature from FCM that allows you to send messages to all devices that subscribed to a particular topic.

    You can view the documentation of topic based messaging if you want to, but in a nutshell, you need to send a POST request to subscribe to the current chat room topic using the format of APPID_receiverType_ReceiverId as shown in CometChat documentation. The complete code for topic subscription is as follows:

    {% c-block %}
    .then(token => {
     console.log('FCM Token:', token);
     var userType = 'group';
     var UID = process.env.REACT_APP_COMETCHAT_GUID;
     var appId = process.env.REACT_APP_COMETCHAT_APP_ID;
     var topic = appId + '_' + userType + '_' + UID;
     var url = 'https://ext-push-notifications.cometchat.com/fcmtokens/' +
       token + '/topics/' + topic;
     fetch(url, {
       method: 'POST',
       headers: new Headers({
         'Content-Type': 'application/json',
       }),
       body: JSON.stringify({appId: appId}),
     })
     .then(response => {
       if (response.status < 200 || response.status >= 400) {
         console.log(
           'Error subscribing to topic: ' +
             response.status +
             ' - ' +
             response.text()
         );
       }
       console.log('Subscribed to "' + topic + '"');
     })
     .catch(error => {
       console.error(error);
     });
    })
    {% c-block-end %}

    Once your browser is subscribed to the topic, it will receive a message object each time a chat message is being sent to the chat room.

    You can handle that message by using the messaging.onMessage  function from Firebase messaging:

    {% c-block %}
    messaging.onMessage(function(payload) {
     var sender = JSON.parse(payload.data.message);
     console.log('Receiving foreground message', sender);
     // Customize notification here
       var notificationTitle = 'New CometChat message';
       var notificationOptions = {
         body: payload.data.alert,
         icon: sender.data.entities.sender.entity.avatar,
       };
       var notification = new Notification(
         notificationTitle,
         notificationOptions
       );
       notification.onclick = function(event) {
         //handle click event onClick on Web Push Notification
         notification.close();
       };
    });
    {% c-block-end %}

    This function will be called each time Firebase received a message from CometChat, and using the data contained in the payload, you can form a new push notification by using the Notification API.

    And now you can go ahead and try the app. Allow the permission request for push notifications and then send any text message. You should be receiving push notifications. Awesome!

    Preventing push notification from self

    You might notice that the browser received a push notification even though you are the one sending the mesage. To prevent push notification when sending a message, you need to update the messaging.onMessage  function to check if the sender is actually the currently logged in user.

    To do that, create a variable to store the user uid inside firebase.js file. You can call it meUid:

    {% c-block %}
    let meUid = ''
    export function initializeFirebase() {
     ...
    }
    {% c-block-end %}

    Now create a function to update its value:

    {% c-block %}
    export function updateFirebaseLoggedInUser(uid) {
     if (firebase.messaging.isSupported()) {
       meUid = uid;
     }
    }
    {% c-block-end %}

    Next, update the messaging.onMessage function to check the value of sender uid and compare it to meUid so that it will only send push notification from other users:

    {% c-block %}
    messaging.onMessage(function(payload) {
     const sender = JSON.parse(payload.data.message);
     console.log('Receiving foreground message', sender);
     // check the uid
     if (sender.data.entities.sender.entity.uid !== meUid) {
       const notificationTitle = 'New CometChat message';
       const notificationOptions = {
         body: payload.data.alert,
         icon: sender.data.entities.sender.entity.avatar,
       };
       const notification = new Notification(
         notificationTitle,
         notificationOptions
       );
       notification.onclick = function(event) {
         notification.close();
       };
     }
    });
    {% c-block-end %}

    Finally, call the updateFirebaseLoggedInUser function from inside the componentDidMount function of Chat component:

    {% c-block %}
    import {updateFirebaseLoggedInUser} from './../firebase';
    ...
    componentDidMount() {
     updateFirebaseLoggedInUser(this.state.user.uid);
     ...
    }
    {% c-block-end %}

    With this, no push notification will be sent when the new message is your own. To try it out, open the app with two different browsers (Chrome and Firefox) and login with different users. Only the receiving browser will send you a push notification. Very nice!

    Enabling Firebase background listener

    If you minimize one of your web browser and send a message from the other browser, you’ll notice that the minimized browser won’t receive any notification. This is because push notification isn’t enabled yet when your browser is put on the background.

    To enable push notification from apps that are put in the background, you need to create a service worker. If you need to learn more about service worker, visit this Google Developer Docs.

    As for the app, all you need to do is create a new JavaScript file named firebase-messaging-sw.js inside your public/ directory with the following content:

    {% c-block %}
    importScripts("https://www.gstatic.com/firebasejs/6.4.0/firebase-app.js");
    importScripts("https://www.gstatic.com/firebasejs/6.4.0/firebase-messaging.js");
    if (firebase.messaging.isSupported()) {
     var config = {
       // your firebase messagingSenderId here
     };
     firebase.initializeApp(config);
     const messaging = firebase.messaging();
     messaging.setBackgroundMessageHandler(function(payload) {
       console.log(' Received background message ', payload);
       var sender = JSON.parse(payload.data.message);
       var notificationTitle = 'New CometChat message';
       var notificationOptions = {
         body: payload.data.alert,
         icon: sender.data.entities.sender.entity.avatar,
       };
       return self.registration.showNotification(
         notificationTitle,
         notificationOptions
       );
     });
     self.addEventListener('notificationclick', function(event) {
       event.notification.close();
     });
    }
    {% c-block-end %}

    Because you have created the foreground listener, I’m pretty sure you understand what this code is doing. It simply set a background message listener using messaging.setBackgroundMessageHandler function. When a message is received by the listener, it will use the payload received to create a push notification and show it to the user.

    Now try sending messages again. You will receive push notifications even if you minimize the browser. Great work!

    Conclusion

    You have now learned how to add push notification feature to your React chat app. You also learned about CometChat and how easy it is to build a custom chat app using its chat SDK. Congratulations on making it this far!

    Don’t forget to checkout CometChat documentation for advanced features such as sending image and voice chat here.

    What to Read Next

    No items found.